/*
    Gn: A Server for the Internet Gopher Protocol(*).
    File: gn/gn.c
    Version 0.6
    
    Copyright (C) 1993  <by John Franks>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    (*) Gopher is a registered trademark of the Univ. of Minn.
*/

#include <stdio.h>
#include <string.h>
#include "gn.h"

main( argc, argv)
int	argc;
char	*argv[];

{
	char	selector[PATHLEN];
	int	itemtype;
	Item	thisitem;

	gn_init( argc, argv);

	get_selector( selector);

	parse_selector( &thisitem, selector, FULL);

	if ( streq( thisitem.gtype, "0v")) {
		send_text_line( VERSION);
		send_end();
		return (0);
	}

	if ( chkaccess( &thisitem, LOG))
		itemtype = chkcache( &thisitem);
	else
		itemtype = DENIED;

	switch (itemtype) {
		case ROOT:
			sendcache( &thisitem);
			break;
		case TEXT:
			sendtext( &thisitem);
			break;
		case RANGE:
			sendrange( &thisitem);
			break;
		case DIR:
			sendcache( &thisitem);
			break;
		case BIN:
			sendbin( &thisitem);
			break;
		case EXEC:
			sendexec( &thisitem);
			break;
		case SEARCH:
			sendsearch( &thisitem);
			break;
		case FORM:
			sendform( &thisitem);
			break;
		case CHOOSE:
			sendchoose( &thisitem);
			break;
		case COMMENT:
			exit( 0);
			break;
		case DENIED:
			senderr( "Sorry, access denied", &thisitem);
			break;
		case UNKNOWN:
			senderr( "Unknown selector type", &thisitem);
			break;
		default:
			senderr( "Unknown server error", &thisitem);
	}
	return (0);
}

