/*
    Gn: A Server for the Internet Gopher Protocol(*).
    File: gn/gn.h
    Version 0.6
    
    Copyright (C) 1993  <by John Franks>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    (*) Gopher is a registered trademark of the Univ. of Minn.
*/

#include <stdio.h>
#include "../config.h"

#define VERSION	"GN Version 0.6e"
#define	PATHLEN	(2048)
#define	MAXLEN	(2048)
#define BUFSIZE	(2048)

#define streq( a, b)	( strcmp( (a), (b)) == 0 )

#ifndef TRUE
#define TRUE	(1)
#endif

#ifndef FALSE
#define FALSE	(0)
#endif

#define FREE	(0)
#define ROOTCHK	(1)
#define DIRCHK	(2)
#define LOG	TRUE
#define NOLOG	FALSE
#define FULL	TRUE
#define PARTIAL	FALSE

#define ROOT	(-1)
#define	TEXT	(0)
#define	DIR	(1)
#define CSO	(2)
#define ERR	(3)
#define SEARCH	(4)
#define EXEC	(5)
#define BIN	(6)
#define RANGE	(7)
#define FORM	(8)
#define CHOOSE	(9)
#define COMMENT	(10)
#define UNKNOWN	(11)
#define	DENIED	(12)

extern char	rootdir[],
		cfname[],
		afname[],
		myhost[],
		remotehost[],
		remaddr[],
		*strlower();

extern int	accesstype,
		wild_match(),
		chkcache(),
		chkaccess();

extern void	gn_init(),
		writelog(),
		getmyhost(),
		sendtext(),
		sendbin(),
		senddir(),
		sendexec(),
		sendform(),
		sendchoose(),
		sendcache(),
		sendrange(),
		sendsearch(),
		parse_selector(),
		parse_cache(),
		cache_index(),
		cache_search(),
		chop(),
		exit(),
		get_remote_info(),
		get_selector(),
		send_text_line(),
		send_cache_line(),
		send_end(),
		senderr(),
		senderr2();

extern FILE	*safer_popen();

typedef struct Item {
	char	selector[PATHLEN],	/* The original selector */
		gtype[PATHLEN],		/*
					 * Typically gopher type 0,1, etc.
					 * but really everything up to first
                                         * '/' in the selector
					 */
		filepath[PATHLEN],	/* Complete pathname of file  */
 		cachepath[PATHLEN],	/* Complete pathname of cache which */
					/* which contains this item */
 		accdir[PATHLEN],	/* path of access file directory */
		extra[PATHLEN],		/* Stuff after the last tab */
		args[PATHLEN];		/* Args for exec */

	long	range_start,		/* Start and end of text file range */
		range_end;

	int	compressed;		/* True if file is compressed */
} Item;


typedef struct Cache_entry {
	char   	type1,			/*
					 * The single char type which is
					 * the first char in the .cache line
					 */
		name[MAXLEN],
		basename[MAXLEN],
		path[MAXLEN],
		host[MAXLEN],
		port[MAXLEN];
} Cache_entry;
