/*
    Gn: A Server for the Internet Gopher Protocol(*).
    File: gn/sio.c
    Version 0.6
    
    Copyright (C) 1993  <by John Franks>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    (*) Gopher is a registered trademark of the Univ. of Minn.
*/

#include <stdio.h>
#include <string.h>
#include "gn.h"


void
get_selector( sel)
char	*sel;
{
	fgets( sel, PATHLEN, stdin);
	chop( sel);
}


void
send_text_line( line)
char	*line;
{
	chop( line);
	if ( streq( line, "."))
	strcat( line, ".");
		/* Double a '.' if on line by itself */
	fputs( line, stdout);
	fputs( "\r\n", stdout);
}

void
send_cache_line( line)
char	*line;
{
	Item    item;
	Cache_entry cache_entry;

	if ( accesstype == DIRCHK) {
		parse_cache(line, &cache_entry);
		parse_selector( &item, cache_entry.path, FULL);
		if (!chkaccess( &item, NOLOG))  
			return;
	}
	fputs( line, stdout);
}


void
send_end()
{
	fputs( ".\r\n", stdout);
}
